function onLoadCollapse() {            
    jQuery(".linkCollapse span[title]").each(function() {
    	var idSep =	"__";
    	var idx = this.id.lastIndexOf(idSep);
    	if (idx >= 0) {
    		toggleCollapse(this.id.substring(idx + idSep.length));
    	}
    });
}

/**
 * Gli id jsf devono avere la forma panel__XXX e label__XXX
 */
function toggleCollapse(id) {
	jsf("panel__" + id).toggle();
	if (jsf("panel__" + id).is(":visible")) {
		jsf("label__" + id)
			.removeClass("linkExpand")
			.addClass("linkCollapse")
			.find(".toggler").html(gMsgHide);
	} else {
		jsf("label__" + id)
			.removeClass("linkCollapse")
			.addClass("linkExpand")
			.find(".toggler").html(gMsgShow);
	}
}

function jsf(id) {
    // Find the dynamic JSF client identifier by looking up
    // the static identifier of its j4j proxy child element
    if (document.getElementById(id) == null) { alert("Couldn't find JSF element: " + id); }
    var realId = document.getElementById(id).title;
    var element = document.getElementById(realId);
    return jQuery(element);
}

function jsfNoError(id) {
    // Find the dynamic JSF client identifier by looking up
    // the static identifier of its j4j proxy child element
    if (document.getElementById(id) == null) { return jQuery("#non_exist_element"); }
    var realId = document.getElementById(id).title;
    var element = document.getElementById(realId);
    return jQuery(element);
}

function unblockUI() {
    jQuery.unblockUI();
}

function blockUI() {
    jQuery.blockUI({
	message: '<h1 style="font-size:20px; color:#FFF; text-align:center;">Operazione in corso...</h1>',
	    css: { 
	    border: 'none', 
	    padding: '15px', 
	    backgroundColor: '#000', 
	    '-webkit-border-radius': '10px', 
	    '-moz-border-radius': '10px', 
	    'border-radius': '10px', 
	    opacity: .5, 
	    color: '#fff', 
	    cursor: 'normal' // prevent cursor to stay busy after page reload
	    },
	    overlayCSS: {
		    backgroundColor: '#000',
		    opacity: 0.2,
		    cursor: 'normal' // prevent cursor to stay busy after page reload
	    }
    });
}

function blockForm() {
    jQuery('form').submit(function () {
	blockUI();
    });
}

function cucInitLeftMenu(cookieMenuName, cookiePath) {
    jQuery('.left-menu-item-container').hide();
    var selectedMenu = jQuery.cookie(cookieMenuName);
    if (selectedMenu) {
        cucExpandLeftMenu(jQuery('#' + selectedMenu));
    }
    jQuery('.left-menu-item-label').click(function() {
        jQuery('.left-menu-item-container').hide();
        jQuery('.menu-selected')
            .removeClass('menu-selected')
            .parents('.left-box').removeClass('menu-container-selected');

        var menu = jQuery(this);
        cucExpandLeftMenu(menu);
    
        // update cookie
        var date = new Date();
        date.setTime(date.getTime() + (365 * 24 * 60 * 60 * 1000));
        jQuery.cookie(cookieMenuName, menu.attr('id'), { path: cookiePath, expires: date });
    });
}

function cucExpandLeftMenu(menu) {
    if (menu.length == 0) return;
    menu.addClass('menu-selected');
    jQuery('.menu-selected').parents('.left-box').addClass('menu-container-selected');
    jQuery(menu.siblings()[0]).show();
}

function isChromePDFViewerEnabled() {
    for (i = 0; i < navigator.plugins.length; i++) {
        if (navigator.plugins[i].name == "Chrome PDF Viewer") {
            return true;
        }
    }
    return false;
}

function isIE9(){
	return jQuery.browser.msie && jQuery.browser.version>8;
}

(function($) {
    $.fn.showMessageOnBlur = function(settings) {
        var config = {blurMessage: 'Type something',
                        blurClass: '',
                        focusClass: ''};

        if (settings) {
            $.extend(config, settings);
        }
        var onBlur = function() {
            // when page is reloaded the input field maintains its value so we
            // check it with blurMessage to apply blur style
            if ($.trim(this.value) == ''
                || this.value == config.blurMessage) {
                this.value = config.blurMessage;
                $(this).addClass(config.blurClass).removeClass(config.focusClass);
            }
        };
        this.blur($.proxy(onBlur, this[0]))
        .focus(function() {
            $(this).addClass(config.focusClass).removeClass(config.blurClass);
            if (this.value == config.blurMessage) {
                this.value = '';
            }
        });
        // don't trigger a real blur event but simply call initialization code
        $.proxy(onBlur, this[0])();

        var coreValFunction = this.val;
        this.val = function(value) {
            // this behavior changed on JQuery 1.4.3
            var text = '';
            if (value === undefined) {
                text = $.proxy(coreValFunction, this)();
            } else {
                text = $.proxy(coreValFunction, this)(value);
            }
            if (text == config.blurMessage) {
                this.addClass(config.blurClass).removeClass(config.focusClass);
                return '';
            }
            this.addClass(config.focusClass).removeClass(config.blurClass);
            return text;
        }
        return this;
    }
})(jQuery);
